import LoadToCurrencyConverter from './loadToCurrencyConverterService'
import { IPerformanceIndicator } from './dataConsumptionContracts'

export default class PerformanceIndicatorAggregateCalculator {
  public static aggregatePerformanceIndicators(
    performanceIndicators: IPerformanceIndicator[]
  ): IPerformanceIndicator {
    const loadToCurrencyConverter = new LoadToCurrencyConverter()
    let currentValue = 0
    let compareValue = 0
    if (
      performanceIndicators[0] &&
      performanceIndicators[1] &&
      performanceIndicators[2]
    ) {
      if (
        !performanceIndicators[0].value ||
        !performanceIndicators[1].value ||
        !performanceIndicators[2].value
      ) {
        currentValue = 0
      } else {
        for (const key in performanceIndicators) {
          const performanceIndicator = performanceIndicators[key]
          const fluidType = parseInt(key)
          currentValue += performanceIndicator.value
            ? loadToCurrencyConverter.Convert(
                performanceIndicator.value,
                fluidType
              )
            : 0
        }
      }
      if (
        !performanceIndicators[0].compareValue ||
        !performanceIndicators[1].compareValue ||
        !performanceIndicators[2].compareValue
      ) {
        compareValue = 0
      } else {
        for (const key in performanceIndicators) {
          const performanceIndicator = performanceIndicators[key]
          const fluidType = parseInt(key)
          compareValue += performanceIndicator.compareValue
            ? loadToCurrencyConverter.Convert(
                performanceIndicator.compareValue,
                fluidType
              )
            : 0
        }
      }
    } else {
      const i = performanceIndicators.length - 1
      if (performanceIndicators[i] && !performanceIndicators[i].value) {
        currentValue = 0
      } else {
        for (const key in performanceIndicators) {
          const performanceIndicator = performanceIndicators[key]
          const fluidType = parseInt(key)
          currentValue += performanceIndicator.value
            ? loadToCurrencyConverter.Convert(
                performanceIndicator.value,
                fluidType
              )
            : 0
        }
      }
      if (performanceIndicators[i] && !performanceIndicators[i].compareValue) {
        compareValue = 0
      } else {
        for (const key in performanceIndicators) {
          const performanceIndicator = performanceIndicators[key]
          const fluidType = parseInt(key)
          compareValue += performanceIndicator.compareValue
            ? loadToCurrencyConverter.Convert(
                performanceIndicator.compareValue,
                fluidType
              )
            : 0
        }
      }
    }

    const agreggatedPerformanceIndicator: IPerformanceIndicator = {
      value: currentValue,
      compareValue: compareValue,
      percentageVariation: 1 - currentValue / compareValue,
    }
    return agreggatedPerformanceIndicator
  }
}
